// efektiivne sortimine standardteegi algoritmiga

#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

ifstream fi("a1sis.txt");
ofstream fo("a1val.txt");

struct kanne {
	string en, pn;
	int eh, mh, ih;
};

bool operator<(const kanne & k1, const kanne & k2) {
	int h1 = k1.eh + k1.mh + k1.ih;
	int h2 = k2.eh + k2.mh + k2.ih;
	if (h1 != h2) {
		return h1 > h2;
	}
	if (k1.pn != k2.pn) {
		return k1.pn < k2.pn;
	}
	return k1.en < k2.en;
}

int main() {
	int n;
	fi >> n;
	vector<kanne> a(n);
	for (int i = 0; i < n; ++i) {
		fi >> a[i].en >> a[i].pn >> a[i].eh >> a[i].mh >> a[i].ih;
	}
	sort(a.begin(), a.end());
	for (int i = 0; i < n; ++i) {
		fo << a[i].en << ' ' << a[i].pn << ' ' << a[i].eh << ' ' << a[i].mh << ' ' << a[i].ih << '\n';
	}
	return 0;
}
